package tut.tutorial.tutorial;

import android.app.IntentService;
import android.content.Intent;
import android.os.Environment;
import android.util.Log;

import java.io.File;
import java.io.FileReader;

public class SettingsService extends IntentService
{
    public static final String SETTINGS_SERVICE = "SettingsService";

    public SettingsService()
    {
        super(SETTINGS_SERVICE);
    }

    @Override
    protected void onHandleIntent(Intent intent)
    {
        if (intent != null)
        {
            Log.v("Xposed", SettingsActivity.KIWI + " " + SETTINGS_SERVICE + " got intent...");
            try
            {
                String s = "";
                File dir = new File(Environment.getDataDirectory() + SettingsActivity.PREFS_PATH);
                File fi = new File(dir, SettingsActivity.PREFS_NAME);
                if (fi.exists())
                {
                    try
                    {
                        FileReader fr = new FileReader(fi);
                        StringBuilder sb = new StringBuilder();
                        char[] buffer = new char[1024];
                        int r = fr.read(buffer);
                        while (r > 0)
                        {
                            sb.append(buffer, 0, r);
                            r = fr.read(buffer);
                        }
                        fr.close();
                        s = sb.toString();
                    }
                    catch (Exception e)
                    {
                        Log.e("Xposed", SettingsActivity.KIWI+" "+SETTINGS_SERVICE+" Exception reading prefs " + e);
                    }
                }
                Intent i = new Intent(SettingsActivity.ACTION_ALL_PACK);
                i.putExtra(SettingsActivity.PACKAGES, s);
                sendBroadcast(i);
                Log.v("Xposed", SettingsActivity.KIWI+" "+SETTINGS_SERVICE+" got intent...");
            }
            catch (Throwable t)
            {
                Log.e("Xposed", SettingsActivity.KIWI+" "+SETTINGS_SERVICE+" Exception in handle intent " + t);
            }
        }
    }
}
